[TOC]

# As a model user

## Introduction

Dynamic restart mode covers the possibility to run again a model starting from data that were already computed on a previous run. It is expected to work both on sequential and parallel modes - for the latter case it will uses up the exact same partitioning as in the first run.

It might be useful in situations such as:

- There is an hardware issue along the line (typically a power failure) and you want to restart the model without recomputing from initial time.
- You want to investigate more closely the behaviour at an advanced point in your runtime, and you may need for instance to write more outputs to understand what's happening. You may in this case modify the code (typically just to add new outputs) and restart close to the moment you wish to investigate.
- You might also want to modify some of the input data and see what happens. This should be treaded by the greatest care; and at the moment some of the modifications you might want won't be accepted (typically if you modify the time steps and are using the ConstantTimeStep policy - the basic one used in most models - you will get an exception when loading the data).

There are currently several limitations - which could all be lifted with a bit of work if the need truly arises (except for the very first one which is model-dependant and is up to the model developer):

- You may use the restart mode only if the Model you're running explicitly support it (typically in this case there is the `InputDataNS::Restart` item in the `InputData` tuple).
- Time step can't be easily modified (see above).
- The sequential or parallel mode used in the first run must be kept as such in the following one. So you can't run the initial run with 12 mpi ranks and then try to rerun it in sequential or with a different number of ranks.

In the models embedded directly in MoReFEM, restart mode is implemented in _Elasticity_, _Hyperelasticity_ and _Heat_ models.


## Input data

### Restart section

Restart is handled in the input data file through a `Restart` section, which should look something like:

````
Restart = {

    -- Time iteration from which we should restart the model (should be present in the first column of the 
	-- 'time_iteration.hhdata' file of the previous run. Put 0 if no restart intended. This value makes only 
	-- sense in 'RunFromPreprocessed' mode. 
	-- Expected format: VALUE
	time_iteration = 0,


	-- Result directory of the previous run (as it was written in Result::OutputDirectory field - so without 
	-- the 'Rank_*'subfolder that is automatically added). Leave empty if no restart intended. 
	-- Expected format: "VALUE"
	data_directory = '',


	-- Whether restart data are written or not. Such data are written only on root processor and only in binary 
	-- format. 
	-- Expected format: 'true' or 'false' (without the quote)
	do_write_restart_data = true

} -- Restart
````

#### Optional writing of the restart data

Even with a model supporting restart, you need to make it work to write in the original run the data required to make it work. The design choice was to write these files in the output directory and in binary format to speed up both reading and writing, but even so you may choose to skip entirely the writing step to speed up the running of your code.

The choice is made in the original run through the `do_write_restart_data` in the `Restart` section. Please notice that even when running a run for restart data you may choose either value here - if true you will be writing additional data that may be used for a further run from restart data.

#### Time iteration

If the field `Restart::time_iteration` is set to zero, the model is not run in restart mode (and the field `data_directory` is altogether ignored).

If you want to run a model in restart mode, you need to specify the proper index here, which is given by the very first column of the `time_iteration.hhdata` file generated in the result directory of the first run (its content looks like:

````
# Time iteration; time; numbering subset id; filename
0;0;1;/path/to/first/run/output/Rank_*/Mesh_1/NumberingSubset_1/solution_time_00000.hhdata
1;0.1;1;/path/to/first/run/output/Rank_*/Mesh_1/NumberingSubset_1/solution_time_00001.hhdata
````
)

If the value of the time iteration given in the Lua file is not found in this file, an exception is thrown.


#### Data directory

This is (almost) the directory generated by the previous run from which you may want to restart.

There is just a subtlety related to mpi: to not bother with the mpi configuration of the run (for instance if all mpi ranks write to the same filesystem or not) we follow the convention to add a subdirectory named `Rank_i` where `i` is the index of the mpi rank considered (even in sequential we generate a `Rank_0` subdirectory).

You should not specify this additional layer here - what is expected is exactly the path you used in the `Result::output_directory` field of the original run.


### Parallelism section

If there is a restart mode implemented for your model, there is also in the input data file a section named `Parallelism` which is closely related to the restart.

As said in the introduction of this note, restart mode share exactly the same parallelism data as the original run - if you run original run with _n_ ranks it is expected you do likewise in the restart run.

To ensure the repartition among ranks is the same, some data related to parallelism needs to be loaded; these are handled in the `Parallelism` section (a link will be added when the documentation will be written - see #1589)

#### Policy

The policy specifies the expected behaviour during your model run.

In the original run, the field should be `Parallel` (or possibly `RunFromPreprocessed`).

In the restart run, the field should be `RunFromPreprocessed`.

#### Directory

`Parallelism::directory` specifies where the partition data are written (it is **not** in the `Result` directory).

This field should hold the same value in the lua files of original and restart runs.


# As an advanced model developer

## Filling the InputData tuple

As explained in the first part of this note, first of all you must provide the fields from which restart data may be fed to your model, by adding in your tuple `InputDataNS::Parallelism` and `InputDataNS::Restart`.

Of course these fields should be added in the Lua files you're using.

## Initialisation 

In most models, the initialization (either in `MyModel::Init()` or `MyVariationalFormulation::Init()`[^varf_naming] depending on your implementation choices - we will assume `MyVariationalFormulation` here but would work similarly if you chose to do it in `MyModel`[]) during a 'normal' run runs a static case and prepare data for the dynamic ones (typically assembling there some operators).

[^varf_naming]: I have used here `MyXXX` (e.g. `MyModel`) so that there are no ambiguity between the base class in MoReFEM library and the one you define yourself while writing your model. In the examples found in MoReFEM library, the convention is to use `Model` and `VariationalFormulation` and let the enclosing namespaces convey the information of the model considered, but I wanted here to avoid any misunderstanding.

To implement restart mode, you need to:

- Identify which steps are not to be done in restart mode (typically running the static case) and separate them from the ones that are required in both cases (typically assembling some bilinear operators).
- Copy into the `Result::OutputDirectory` the solutions of the time iterations that won't be recomputed in restart mode.
- Load some specific data that give the state at the time iteration from which you want to start from.

The last point is crucial: you should strive to identify which quantities are really required to make your model work - no need to slow down your model by serializing data that are not actually required. [^serializing_in_hyperelasticity].

[^serializing_in_hyperelasticity]: If I take the example of the hyperelastic model as it is provided in MoReFEM library, there are at the time of this writing 9 `GlobalVector` and 2 `GlobalMatrix` in its `MyVariationalFormulation` object, not counting system rhs and solution. Of all these data, only two vectors actually need to be saved to enable further restart - it would have slowed down uselessly the model if all was serialized at each time step in a normal run.

The end of your `SupplInit()` method[^suppl_methods] should include something like:

[^suppl_methods]: By convention methods name this way are virtual methods that provide model-specific initialization instructions.


````
decltype(auto) time_manager = this->GetTimeManager();

if (!time_manager.IsInRestartMode())
{
    ... // model-specific methods only relevant when not in restart mode
} 
else
{
    CopySolutionFilesFromOriginalRun();
    LoadRestartData();
}
````

`TimeManager::IsInRestartMode()` is a method that returns true if you chose in `Restart::TimeIterationIndex` a non-zero value (the comment in Lua files pinpoints that explicitly).

`CopySolutionFilesFromOriginalRun` and `LoadRestartData` are two methods you should provide in your `VariationalFormulation` (name them as you like - these are mere suggestions).


### MyVariationalFormulation::CopySolutionFilesFromOriginalRun()

The point of this method is to:

- Copy the solutions from the time iterations that were computed by the original run and are prior to the time iteration index provided in restart section in the input data file.
- Fill the `time_iteration.hhdata` file in `Result::OutputDirectory` with the related informations.

There is a specific function named `Advanced::RestartNS::CopySolutionFilesFromOriginalRun()` which does the job for a given `GodOfDof` and `NumberingSubset`. Make sure to call in your `MyVariationalFormulation::CopySolutionFilesFromOriginalRun()` this function for all relevant `GodOfDof` / `NumberingSubset` combination (in the simplest model there is one such call but there might be much more in more sophisticated ones).

### MyVariationalFormulation::LoadRestartData()

In this method, you must fill internals of your class with the proper data loaded from the previous run (we will see shortly how to store them in the first place).

There are some facility functions to do so:
    - `Advanced::RestartNS::LoadGlobalVectorFromData()`
    - `Advanced::RestartNS::LoadGlobalMatrixFromData()`

Some don't exist yet but will be added when needed (typically serialization/deserialization of `ParameterAtQuadraturePoint` will probably be required for some models).

These facility functions calls look like:

````
Advanced::RestartNS::LoadGlobalVectorFromData(time_manager, god_of_dof, "displacement", GetNonCstDisplacement());
````

where:

- "displacement" is a moniker to know which files should be loaded. The exact same name will have to be used in the serialization part we'll see shortly.
- `GetNonCstDisplacement()` is a non constant accessor to the `GlobalVector` you want to fill. Naming is of course entirely up to you, but this method assumes the layout has already been allocated properly (through `AllocateGlobalVector()` calls - but you should already have done that for the normal runs without the restart).


## WriteRestartData

You of course need to save the data in the original run to be able to load them in the restart run.

In all the models in which restart has been deployed, the more natural place to do so is in the `MyModel::SupplInitializedStep()` [^suppl_methods], with something like:


````
if (this->DoWriteRestartData())
    GetVariationalFormulation().WriteRestartData();
````

where:
    - `DoWriteRestartData()` is a method defined in the base `Model` class
    - `GetVariationalFormulation()` is an accessor to your `VariationalFormulation`; of course adapt the call here if your model is more complex and sports more variational formulations.


### MyVariationalFormulation::WriteRestartData()

The method called above has to be implemented in your `MyVariationalFormulation`; it should look like:

````
  decltype(auto) time_manager = this->GetTimeManager();
  decltype(auto) god_of_dof = this->GetGodOfDof();

  Advanced::RestartNS::WriteDataForRestart(time_manager, god_of_dof, "displacement", GetVectorCurrentDisplacement()));
  ...
````

It should be written accordingly to `MyVariationalFormulation::LoadRestartData()`: you should write all that will have to be loaded later, and be consistent in the moniker used to serialize/deserialize data.

## Check it!

Of course it is very important to check you obtain the exact same results as you got in the original run!

In the models in which it is implemented in MoReFEM library, the `CheckResults` executables have been expanded to check this is the case.

The quick guide I have written here doesn't cover all cases: for instance in `Elasticity` and `Heat` models you need to ensure the boundary conditions are properly applied on the very first call, and you may have to adjust a bit your code to make sure it is properly done (both those models `MyModel::Forward()` methods had to be modified for that purpose - a condition such as `if (GetTimeManager().NtimeModified() == 1)` won't work in restart mode for instance).

I found it useful while adding restart to _Elasticity_ and _Heat_ models to provide a temporary method which prints the very first values of the content of the vectors (through helper function `Wrappers::Petsc::DisplaySomeValues`) at restart time and in `Model::SupplInitializeStep()`): you may check easily this way that in the normal and the restart run the content of the data in the restart time step is exactly the same.

